unit Unit2;

{  draw procedures }

interface

uses dialogs;

type TmouseAction = (maDown,maMove,maUp);

procedure mouseproc(ma : TmouseAction; x,y : smallInt);
procedure showmap1;
procedure showmap2;
procedure copymap12;

implementation

uses unit1,unit3;

const maxfreeStroke = 8000;

var px,py : smallInt;
    mouseAction : TmouseAction;
    DCC   : byte = 0;
    x1,y1,x2,y2,x3,y3 : smallInt;
    freeBuf : array[0..2000] of word;
    freePosX : smallInt;
    freePosY : smallInt;
    oldstroke : byte;
    newstrdir : boolean;

procedure showmap1;
begin
 map2.Canvas.draw(0,0,map1);
 form1.PaintBox1.Canvas.Draw(0,0,map2);
end;

procedure showmap2;
begin
 form1.PaintBox1.Canvas.Draw(0,0,map2);
end;

procedure copymap12;
begin
 map2.Canvas.Draw(0,0,map1);
end;

procedure drawproc2;
begin
 case mouseAction of
  maDown : with map2 do
            begin
             xpencolor := pencolor;
             xpenlevel := 0;
             xpenwidth := penwidth;
             x1 := px; y1 := py;
             DCC := 1;
            end;
  maMove : begin
            if DCC = 1 then DCC := 2;
            if DCC = 2 then
             with map2 do
              begin
               copymap12;
               x2 := px; y2 := py;
               xusebrush := false;
               case menubutton of
                mbLine    : xline(x1,y1,x2,y2);
                mbEllipse : Xellipse(x1,y1,x2,y2);
                mbRect    : XfillRect(x1,y1,x2,y2,10);
               end;
               showmap2;
              end;
            end;
  maUp : begin
          if DCC = 2 then
           with map1 do
            begin
             xpencolor := pencolor;
             xpenwidth := penwidth;
             xpenlevel := 0;
             xusebrush := false;
             case menubutton of
               mbLine    : xline(x1,y1,x2,y2);
               mbEllipse : Xellipse(x1,y1,x2,y2);
               mbRect    : Xfillrect(x1,y1,x2,y2,10);
              end;
            end;
          DCC := 0;
         end;
 end;
end;

//-- freedraw ------------

// strokes are saved in freeBuf [ ]
// drawing is into map2 , redraw in map1

procedure paintfreeGraph;
//paint strokes in freeBuf
var snr : word;  //stroke nr
    str : shortInt;
    w   : word;  //in array
    s   : byte;  //stroke shift count in word
    x,y : integer;
begin
 with map1 do
  begin
   x := freePosX;
   y := freePosY;
   Xpencolor := penColor;
   Xpenlevel := 0;
   Xpenwidth := penWidth;
   Xdot(x,y);
   for snr := 0 to freeBuf[0]-1 do
    begin
     w := 1 + (snr shr 2);
     s := (snr and $3) shl 2;//shift count 0,4,8,12
     str := (freeBuf[w] shr s) and $f;
     while str >= 0 do
      begin
       case str of
        0,8  : inc(x);
        1,9  : begin
                inc(x); dec(y);
               end;
        2,10 : dec(y);
        3,11 : begin
                dec(x); dec(y);
               end;
        4,12 : dec(x);
        5,13 : begin
                dec(x); inc(y);
               end;
        6,14 : inc(y);
        7,15 : begin
                inc(x); inc(y);
               end;
       end;//case
       dec(str,8);
       Xdot(x,y);
      end;//while
    end;//with
  end;//for
end;

function sign(v : single) : integer;
//return 1 for positive, -1 for negative number
begin
 if v < 0 then result := -1 else result := 1;
end;

procedure savestroke(str : byte; var saved : boolean);
//store stroke str in buffer[bufNr]
//if possible, combine with previous stroke
//report in "saved" : true=OK
var n,n1,mask : word;  //stroke number  0..4999
    w : word;          //word of stroke 1..4000 in array
    s : byte;          //shift count for stroke position
begin
 n := freeBuf[0];
 if n = maxfreestroke - 1 then
  begin
   saved := false;
   exit;
  end;

 saved := true;
 if (n = 0) then
  begin
   oldstroke := 0;
   newstrdir := true;
  end
   else
    begin
     n1 := n - 1;                   //n1: old stroke#
     w := 1 + (n1 shr 2);           //1+ : [0] holds stroke count
     s := (n1 and $3) shl 2;        //s = 0,4,8,12
     if (oldstroke = str) then
      begin
       freeBuf[w] := freeBuf[w] or (8 shl s);  //add bit 3 for double move
       newstrdir := false;
       oldstroke := oldstroke or $8;
       exit;
      end;
     if newstrdir then
      begin
       case (oldstroke shl 4) or str of
        $02,$20 : str := $f1;
        $06,$60 : str := $f7;
        $46,$64 : str := $f5;
        $24,$42 : str := $f3;
       end;//case
       if str > $f0 then
        begin
         str := str and $7;
         mask := $ffff xor ($f shl s);
         freebuf[w] := (freeBuf[w] and mask) or (str shl s);
         oldstroke := str;
         exit;
        end;
      end;//if newstr
    end;

  w := 1 + (n shr 2);
  s := (n and $3) shl 2;
  mask := $ffff xor ($f shl s);
  freeBuf[w] := (freeBuf[w] and mask) or (str shl s);
  inc(n);
  freeBuf[0] := n;
  newstrdir := oldstroke <> str; //== new code end
  oldstroke := str;
end;

function recordstrokes : boolean;
//called by mouse move
//translate mouse movement (x2,y2)--> (x3,y3) into strokes and store in buffer
const dir2stroke: array[0..15] of byte =  (0,0,0,4,0,0,0,0,6,0,7,5,2,0,1,3);
var rx,ry,dx,dy : single;
    dir,stroke,i : byte;   //direction
    steps,px1,py1,px2,py2 : integer;
begin
 dx := x3 - x2;
 dy := y3 - y2;
 if abs(dx) > abs(dy) then
  begin
   steps := trunc(abs(dx));
   dy := dy/steps; dx := sign(dx);      //horizontal orientation
  end
  else begin
        steps := trunc(abs(dy));
        dx := dx/steps; dy := sign(dy); //vertical orientation
       end;
 px1 := x2; py1 := y2;
 rx := x2; ry := y2;
 for i := 1 to steps do
  begin
   rx := rx + dx; ry := ry + dy;
   px2 := trunc(rx+0.5);
   py2 := trunc(ry+0.5);
   dir := 0;
   if px2 > px1 then dir := dir or 2;
   if px2 < px1 then dir := dir or 3;
   if py2 > py1 then dir := dir or 8;
   if py2 < py1 then dir := dir or $c;
   stroke := dir2stroke[dir];
   savestroke(stroke,result);
   if result = false then exit;  //buffer full

   px1 := px2; py1 := py2;
  end;
end;

procedure DrawFree;
//drawing in map2
//on mouse-up: map1 with corrections
begin
 case mouseAction of
  maDown : begin
            DCC := 1;
            freeBuf[0] := 0;
            with map2 do
             begin
              Xpenlevel := 0;
              Xpencolor := pencolor;
              XpenWidth := penwidth;
              freePosX := px;
              freePosY := py;
              x1 := px; y1 := py;
              x2 := x1; y2 := y1;
             end;
           end;
  maMove : begin
            if DCC = 1 then DCC := 2;
            if DCC = 2 then
            begin
             x3 := px; y3 := py;
             if recordstrokes then
              begin
               map2.Xline(x2,y2,x3,y3);
               x2 := x3; y2 := y3;
               with map2 do
                form1.PaintBox1.Canvas.copyrect(Xmodrect,map2.Canvas,Xmodrect);
               end
              else
               begin
                DCC := 3;                         //terminate
                showmessage('buffer full');
               end;
             end;
           end;
  maUp   : begin
            if DCC >= 2 then
             begin
              paintFreeGraph;
              showmap1;
             end;
            DCC := 0;
           end;
 end;//case
end; 

procedure drawFill;
begin
 if mouseAction = maDown then
  with map1 do
   begin
    xbrushcolor := pencolor;
    xbrushlevel := 2;
    xfillstyle := fillpattern;
    xfillsize := fms8;
    xfloodfill(px,py);
    showmap1;
   end;
end;

//--- main call

procedure mouseproc(ma : TmouseAction; x,y : smallInt);
begin
 px := x; py := y;
 mouseaction := ma;
 case menubutton of
  mbLine,
  mbEllipse,
  mbRect    : drawproc2;
  mbFree    : drawFree;
  mbFill    : drawFill;
 end;
end;

end.
 